/*
  boost_regex_utility.hpp

  Copyright (C) 2011 Taiji Yamada <taiji@aihara.co.jp>
 */
#ifndef _BOOST_REGEX_UTILITY_HPP_
#define _BOOST_REGEX_UTILITY_HPP_
#include <map>
#include <boost/regex.hpp>

namespace boost {

struct string_regex_map : public std::map<std::string, regex> {
  regex &operator[](const std::string &k)
  {
    std::map<std::string, regex>::iterator i = lower_bound(k);
    if (i == end() || key_comp()(k, (*i).first))
      i = insert(i, value_type(k, regex(k)));
    return (*i).second;
  }
  regex &at(const std::string &k,
	    regex::flag_type flags = regex_constants::normal)
  {
    std::map<std::string, regex>::iterator i = lower_bound(k);
    if (i == end() || key_comp()(k, (*i).first))
      i = insert(i, value_type(k, regex(k, flags)));
    return (*i).second;
  }
};

}

#endif
