/*
  repeater-test.cc

  Copyright (C) 2011 Taiji Yamada <taiji@aihara.co.jp>
 */
#include <iostream>
#include <boost/lexical_cast.hpp>
#include "date_time_numeric.hpp"
#include "repeater.hpp"
#include "date_time_repeater.hpp"
using namespace std;
using namespace boost;

int main00()
{
  repeater<int, int> A[] = {
    repeater<int, int>(4),
    repeater<int, int>(4,1,1UL),
    repeater<int, int>(4,1,4),
    repeater<int, int>(4,1,0UL),
    repeater<int, int>(4,1,11),
    repeater<int, int>(4,1,8UL),
    repeater<int, int>(4,3,4),
    repeater<int, int>(4,3,0UL),
    repeater<int, int>(4,3,11),
    repeater<int, int>(4,3,3UL),
  };
  string a[sizeof(A)/sizeof(A[0])];

  for (size_t i=0; i<sizeof(A)/sizeof(A[0]); ++i) {
    cout << A[i] << "\tcount: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    a[i] = lexical_cast<string>(A[i]);
    A[i] = lexical_cast<repeater<int, int> >(a[i]);
    cout << A[i] << "\tcount: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    assert(a[i] == lexical_cast<string>(A[i]));
  }

  return 0;
}
int main01()
{
  repeater<gregorian::date, gregorian::date_duration> A[] = {
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(1), 1),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(1), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(1), 0),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(1), gregorian::date(2011, 12, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(1), 31),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(4), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(4), 0),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(4), gregorian::date(2011, 12, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(4), 8),
  };
  string a[sizeof(A)/sizeof(A[0])];

  for (size_t i=0; i<sizeof(A)/sizeof(A[0]); ++i) {
    cout << A[i] << "\tdate count: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    a[i] = lexical_cast<string>(A[i]);
    A[i] = lexical_cast<repeater<gregorian::date, gregorian::date_duration> >(a[i]);
    cout << A[i] << "\tdate count: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    assert(a[i] == lexical_cast<string>(A[i]));
  }

  return 0;
}
int main02()
{
  repeater<gregorian::date, gregorian::years> A[] = {
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(1), 1UL),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(1), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(1), 0UL),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(1), gregorian::date(2031, 12, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(1), 21UL),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(4), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(4), 0UL),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(4), gregorian::date(2031, 12, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(4), 6UL),
  };
  string a[sizeof(A)/sizeof(A[0])];

  for (size_t i=0; i<sizeof(A)/sizeof(A[0]); ++i) {
    cout << A[i] << "\tyear count: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    a[i] = lexical_cast<string>(A[i]);
    A[i] = lexical_cast<repeater<gregorian::date, gregorian::years> >(a[i]);
    cout << A[i] << "\tyear count: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    assert(a[i] == lexical_cast<string>(A[i]));
  }

  return 0;
}
int main03()
{
  repeater<gregorian::date, gregorian::months> A[] = {
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(12), 1UL),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(12), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(12), 0UL),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(12), gregorian::date(2031, 12, 11)),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(12), 21UL),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(4*12), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(4*12), 0UL),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(4*12), gregorian::date(2031, 12, 11)),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(4*12), 6UL),
  };
  string a[sizeof(A)/sizeof(A[0])];

  for (size_t i=0; i<sizeof(A)/sizeof(A[0]); ++i) {
    cout << A[i] << "\tmonth count: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    a[i] = lexical_cast<string>(A[i]);
    A[i] = lexical_cast<repeater<gregorian::date, gregorian::months> >(a[i]);
    cout << A[i] << "\tmonth count: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    assert(a[i] == lexical_cast<string>(A[i]));
  }

  return 0;
}
int main04()
{
  repeater<gregorian::date, gregorian::weeks> A[] = {
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(52), 1UL),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(52), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(52), 0UL),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(52), gregorian::date(2031, 12, 11)),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(52), 21UL),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(4*52), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(4*52), 0UL),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(4*52), gregorian::date(2031, 12, 11)),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(4*52), 6UL),
  };
  string a[sizeof(A)/sizeof(A[0])];

  for (size_t i=0; i<sizeof(A)/sizeof(A[0]); ++i) {
    cout << A[i] << "\tweek count: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    a[i] = lexical_cast<string>(A[i]);
    A[i] = lexical_cast<repeater<gregorian::date, gregorian::weeks> >(a[i]);
    cout << A[i] << "\tweek count: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    assert(a[i] == lexical_cast<string>(A[i]));
  }

  return 0;
}
int main05()
{
  repeater<posix_time::ptime, posix_time::time_duration> A[] = {
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11))),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(24,0,0,0), 1UL),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(24,0,0,0), posix_time::ptime(gregorian::date(2011, 11, 11))),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(24,0,0,0), 0UL),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(24,0,0,0), posix_time::ptime(gregorian::date(2031, 12, 11))),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(24,0,0,0), 7336UL),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(4*24,0,0,0), posix_time::ptime(gregorian::date(2011, 11, 11))),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(4*24,0,0,0), 0UL),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(4*24,0,0,0), posix_time::ptime(gregorian::date(2031, 12, 11))),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(4*24,0,0,0), 1834UL),
  };
  string a[sizeof(A)/sizeof(A[0])];

  for (size_t i=0; i<sizeof(A)/sizeof(A[0]); ++i) {
    cout << A[i] << "\ttime count: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    a[i] = lexical_cast<string>(A[i]);
    A[i] = lexical_cast<repeater<posix_time::ptime, posix_time::time_duration> >(a[i]);
    cout << A[i] << "\ttime count: " << A[i].count() << "\tlast: " << A[i].last() << endl;
    assert(a[i] == lexical_cast<string>(A[i]));
  }

  return 0;
}

int main11()
{
  repeater<gregorian::date, gregorian::date_duration> v, vs[] = {
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(1), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(1), gregorian::date(2011, 12, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(5), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(5), gregorian::date(2011, 12, 11)),
  };
  for (size_t k=0; k<sizeof(vs)/sizeof(vs[0]); ++k) {
    v = vs[k];
    cout << v << "\tdate count: " << v.count() << "\tlast: " << v.last() << endl;
    gregorian::date w, ws[] = { gregorian::date(2011, 11,  5), gregorian::date(2011, 11, 11), gregorian::date(2011, 12,  5), gregorian::date(2011, 12, 11), gregorian::date(2011, 12, 20) };
    for (gregorian::date i=v.front; v.is_repeat() && !v.is_unlimited() && i<=v.back; i+=v.diff)
      cout << i << endl;
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> a = v.after(w);
      cout << (a ? *a : gregorian::date()) << "\tafter  " << w << endl;   
    }
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> b = v.before(w);
      cout << (b ? *b : gregorian::date()) << "\tbefore " << w << endl;
    }
    cout << endl;
  }
  return 0;
}
int main12()
{
  repeater<gregorian::date, gregorian::years> v, vs[] = {
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(1), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(1), gregorian::date(2031, 12, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(4), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(4), gregorian::date(2031, 12, 11)),
  };
  for (size_t k=0; k<sizeof(vs)/sizeof(vs[0]); ++k) {
    v = vs[k];
    cout << v << "\tyear count: " << v.count() << "\tlast: " << v.last() << endl;
    gregorian::date w, ws[] = { gregorian::date(2011, 11,  5), gregorian::date(2011, 11, 11), gregorian::date(2011, 12,  5), gregorian::date(2031, 12, 11), gregorian::date(2031, 12, 20) };
    for (gregorian::date i=v.front; v.is_repeat() && !v.is_unlimited() && i<=v.back; i+=v.diff)
      cout << i << endl;
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> a = v.after(w);
      cout << (a ? *a : gregorian::date()) << "\tafter  " << w << endl;   
    }
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> b = v.before(w);
      cout << (b ? *b : gregorian::date()) << "\tbefore " << w << endl;
    }
    cout << endl;
  }
  return 0;
}
int main13()
{
  repeater<gregorian::date, gregorian::months> v, vs[] = {
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(1), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(1), gregorian::date(2013, 12, 11)),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(4), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::months>(gregorian::date(2011, 11, 11), gregorian::months(4), gregorian::date(2013, 12, 11)),
  };
  for (size_t k=0; k<sizeof(vs)/sizeof(vs[0]); ++k) {
    v = vs[k];
    cout << v << "\tmonth count: " << v.count() << "\tlast: " << v.last() << endl;
    gregorian::date w, ws[] = { gregorian::date(2011, 11,  5), gregorian::date(2011, 11, 11), gregorian::date(2011, 12,  5), gregorian::date(2013, 12, 11), gregorian::date(2013, 12, 20) };
    for (gregorian::date i=v.front; v.is_repeat() && !v.is_unlimited() && i<=v.back; i+=v.diff)
      cout << i << endl;
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> a = v.after(w);
      cout << (a ? *a : gregorian::date()) << "\tafter  " << w << endl;   
    }
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> b = v.before(w);
      cout << (b ? *b : gregorian::date()) << "\tbefore " << w << endl;
    }
    cout << endl;
  }
  return 0;
}
int main14()
{
  repeater<gregorian::date, gregorian::weeks> v, vs[] = {
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(1), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(1), gregorian::date(2012,  4, 11)),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(4), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::weeks>(gregorian::date(2011, 11, 11), gregorian::weeks(4), gregorian::date(2012,  4, 11)),
  };
  for (size_t k=0; k<sizeof(vs)/sizeof(vs[0]); ++k) {
    v = vs[k];
    cout << v << "\tweek count: " << v.count() << "\tlast: " << v.last() << endl;
    gregorian::date w, ws[] = { gregorian::date(2011, 11,  5), gregorian::date(2011, 11, 11), gregorian::date(2011, 12,  5), gregorian::date(2012,  4, 11), gregorian::date(2012,  4, 20) };
    for (gregorian::date i=v.front; v.is_repeat() && !v.is_unlimited() && i<=v.back; i+=v.diff)
      cout << i << endl;
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> a = v.after(w);
      cout << (a ? *a : gregorian::date()) << "\tafter  " << w << endl;   
    }
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> b = v.before(w);
      cout << (b ? *b : gregorian::date()) << "\tbefore " << w << endl;
    }
    cout << endl;
  }
  return 0;
}
int main15()
{
  repeater<posix_time::ptime, posix_time::time_duration> v, vs[] = {
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11))),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(24,0,0), posix_time::ptime(gregorian::date(2011, 11, 11))),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(24,0,0), posix_time::ptime(gregorian::date(2011, 12, 11))),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(5*24,0,0), posix_time::ptime(gregorian::date(2011, 11, 11))),
    repeater<posix_time::ptime, posix_time::time_duration>(posix_time::ptime(gregorian::date(2011, 11, 11)), posix_time::time_duration(5*24,0,0), posix_time::ptime(gregorian::date(2011, 12, 11))),
  };
  for (size_t k=0; k<sizeof(vs)/sizeof(vs[0]); ++k) {
    v = vs[k];
    cout << v << "\ttime count: " << v.count() << "\tlast: " << v.last() << endl;
    posix_time::ptime w, ws[] = { posix_time::ptime(gregorian::date(2011, 11,  5)), posix_time::ptime(posix_time::ptime(gregorian::date(2011, 11, 11))), posix_time::ptime(gregorian::date(2011, 12,  5)), posix_time::ptime(gregorian::date(2011, 12, 11)), posix_time::ptime(gregorian::date(2011, 12, 20)) };
    for (posix_time::ptime i=v.front; v.is_repeat() && !v.is_unlimited() && i<=v.back; i+=v.diff)
      cout << i << endl;
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<posix_time::ptime> a = v.after(w);
      cout << (a ? *a : posix_time::ptime()) << "\tafter  " << w << endl;   
    }
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<posix_time::ptime> b = v.before(w);
      cout << (b ? *b : posix_time::ptime()) << "\tbefore " << w << endl;
    }
    cout << endl;
  }
  return 0;
}

int main()
{
  main00(); cout << endl;
  main01(); cout << endl;
  main02(); cout << endl;
  main03(); cout << endl;
  main04(); cout << endl;
  main05(); cout << endl;

  main11(); cout << endl;
  main12(); cout << endl;
  main13(); cout << endl;
  main14(); cout << endl;
  main15(); cout << endl;

  return 0;
}
